import urllib.request
import os
import logging

from matemat.interfacing.dispenser import Dispenser
from matemat.webserver.config import get_config


class UncannyDispenser(Dispenser):

    def __init__(self):
        super().__init__()
        self.logger = logging.getLogger('UncannyDispenser')

    def dispense(self, product, amount):
        c = get_config().get('interfaces', {})
        slot = c.get(f'productmap{product.id}')
        if not slot:
            # Noting to dispense (e.g. virtual item)
            return True
        url = os.path.join(c.get('host', 'http://127.0.0.1:8000/'), 'dispense', str(slot))
        self.logger.info(url)
        try:
            request = urllib.request.urlopen(url)
        except BaseException as e:
            self.logger.error(str(e))
            return False
        return request.getcode() == 200
